<?php

		// The BOOKMARKSDB common function file	//
		// copyright 2001 Antonio Bonifati	//
		// see COPYING for license details	//

// all that you might want to change is here
require 'CONF.php';

// prevent pages to be cached if requested in the config file
if (NOCACHE) no_cache();

// outputs some raw HTTP header
// to prevent a page from being cached by most browsers and proxies
// this must be called before any actual output is sent either
// by normal HTML tags or from PHP. See header function in the PHP manual.
function no_cache()
{
   header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
   header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
                                                         // always modified
   header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
   header ("Pragma: no-cache");                          // HTTP/1.0
}

// returns the internet protocol name corresponding to code
// could also be implemented using an hash
// be warning if you want to change these: they are
// also hard-coded in other scripts
function protocol_name($code)
{
   switch ($code)
   {
      case 'H': return 'http';          // HTTP
      case 'F': return 'ftp';           // FTP
      case 'f': return 'file';          // FILE
      case 'G': return 'gopher';        // GOPHER
      case 'M': return 'mailto';        // MAILTO
      case 'N': return 'news';          // NEWS
      case 'n': return 'nntp';          // NNTP
      case 'T': return 'telnet';        // TELNET
      case 'W': return 'wais';          // WAIS
   }
}

// connect to the mSQL database server
// using permanent connection if you can
function try_msql_pconnect()
{
   global $db;

   HOSTNAME?$db=msql_pconnect(HOSTNAME):$db=msql_pconnect()
      or die(msql_error(). '<br><font color="red">
Please check HOSTNAME in the configuration file (CONF.php)<br>
and ensure a mSQL server is running there.'. HTMLend);
}

// try to open db DBNAME
function try_msql_selectdb()
{
   msql_selectdb(DBNAME)
      or die(msql_error(). '<br>
<font color="red">Cannot open database '. DBNAME. '.<br>
* Is msql daemon running on '. (HOSTNAME?HOSTNAME:'localhost') .'?<br>
If not start it and then restart Apache on this server.<br>
* Have you set up the program correctly?<br>
If not, please use the install.php script to create the database first.'. HTMLend);
}

// does the query most often done on an entry.
function do_listing_query($cond='')
{
   global $parent;

   $qid=msql_query("SELECT id, name, url, type, comment FROM bookmarks WHERE parent=$parent".
		   " $cond ". (ORDERBY ? (' ORDER BY '. ORDERBY):('')))
      or die(msql_error(). '<br>
<font color="red">Query failed.<br>
Please check parent parameter.<br>
If it is right please check query in '. __FILE__ .' and '. DBNAME .' database structure.<br>
To restore the database you can drop it and then ricreate it with install.php<br>
but of course doing so you will lose all the data you put in it.'. HTMLend);

   return $qid;
}

// function used by print_tree (in all.php) and print_rest_of_tree (in move.php)
function do_indent()
{
   global $reclevel;
   if ($reclevel)
      printf(INDENTMARK, INDENTWIDTH * $reclevel);
}
?>
